#
# Rebuild option:
#
#   --with spoofing           enables the syslog-ng feature spoof-source
#                             (see README.spoof for more information)
#

%define sbindir   /sbin
%define spoofing  1
%{?_with_nospoofing:%define spoofing 0}

Name:             syslog-ng
Version:          2.0.6
Release:          2.1%{?dist}
Summary:          Syslog replacement daemon

Group:            System Environment/Daemons
License:          GPL
URL:              http://www.balabit.com/products/syslog_ng/
Source0:          http://www.balabit.com/downloads/syslog-ng/2.0/src/syslog-ng-%{version}.tar.gz
Source1:          syslog.log
Patch0:           syslog-ng-2.0-init.patch
Patch1:           syslog-ng-1.6.7-logrotate.patch
BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:    flex, which, glib2-devel
BuildRequires:    tcp_wrappers
BuildRequires:    eventlog-devel
%if %{spoofing}
BuildRequires:    libnet-devel >= 1.1
%endif
Requires:         logrotate
Requires(post):   chkconfig, initscripts
Requires(preun):  chkconfig, initscripts
Requires(postun): initscripts
#
# Keep initscripts and vixie-cron happy
#
Provides:         syslog

%description
syslog-ng, as the name shows, is a syslogd replacement, but with new 
functionality for the new generation. The original syslogd allows 
messages only to be sorted based on priority/facility pairs; syslog-ng 
adds the possibility to filter based on message contents using regular 
expressions. The new configuration scheme is intuitive and powerful. 
Forwarding logs over TCP and remembering all forwarding hops makes it 
ideal for firewalled environments.


%prep
%setup -q -n syslog-ng-%{version}
%patch1 -p1
%patch0 -p1 -b .initfixes
%{__sed} -i  's|^#!/usr/local/bin/perl|#!%{__perl}|' contrib/relogger.pl
chmod a-x contrib/syslog2ng

%build
%configure --sbindir=%{sbindir}
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT

install -d -m 755 $RPM_BUILD_ROOT%{_initrddir}
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -d -m 755 $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d

install -p -m 755 contrib/fedora-packaging/syslog-ng.init \
    $RPM_BUILD_ROOT%{_initrddir}/syslog-ng
install -p -m 644 contrib/fedora-packaging/syslog-ng.conf \
    $RPM_BUILD_ROOT%{_sysconfdir}/syslog-ng.conf
install -p -m 644 contrib/fedora-packaging/syslog-ng.sysconfig \
    $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/syslog-ng
install -p -m 644 %{SOURCE1} \
    $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/syslog

# Vim syntax file
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}
install -p -m 644 contrib/syslog-ng.vim $RPM_BUILD_ROOT%{_datadir}/%{name}/
for vimver in 63 64 70 ; do
    install -dm 755 $RPM_BUILD_ROOT%{_datadir}/vim/vim$vimver/syntax
    ln -s %{_datadir}/%{name}/syslog-ng.vim $RPM_BUILD_ROOT%{_datadir}/vim/vim$vimver/syntax
done


%clean
rm -rf $RPM_BUILD_ROOT


%post
# only rpm -i (not rpm {-U|-F})
if [ $1 = 1 ]; then
    /sbin/chkconfig --add syslog-ng
#   /sbin/service syslog-ng start
fi

%preun
# only rpm -e (not rpm {-U|-F})
if [ $1 = 0 ]; then
    /sbin/service syslog-ng stop > /dev/null 2>&1 || :
    /sbin/chkconfig --del syslog-ng
fi

%postun
# only rpm {-U|-F} (not rpm -e)
if [ $1 = 1 ]; then
    /sbin/service syslog-ng condrestart
fi


%triggerin -- vim-common
VIMVERNEW=`rpm -q --qf='%%{epoch}:%%{version}\n' vim-common | sort | tail -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
[ -d %{_datadir}/vim/vim${VIMVERNEW}/syntax ] && \
    ln -sf %{_datadir}/%{name}/syslog-ng.vim %{_datadir}/vim/vim${VIMVERNEW}/syntax || :

%triggerun -- vim-common
VIMVEROLD=`rpm -q --qf='%%{epoch}:%%{version}\n' vim-common | sort | head -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
[ $2 = 0 ] && rm -f %{_datadir}/vim/vim${VIMVEROLD}/syntax/syslog-ng.vim || :

%triggerpostun -- vim-common
VIMVEROLD=`rpm -q --qf='%%{epoch}:%%{version}\n' vim-common | sort | head -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
VIMVERNEW=`rpm -q --qf='%%{epoch}:%%{version}\n' vim-common | sort | tail -n 1 | sed -e 's/[0-9]*://' | sed -e 's/\.[0-9]*$//' | sed -e 's/\.//'`
if [ $1 = 1 ]; then
    rm -f %{_datadir}/vim/vim${VIMVEROLD}/syntax/syslog-ng.vim || :
    [ -d %{_datadir}/vim/vim${VIMVERNEW}/syntax ] && \
        ln -sf %{_datadir}/%{name}/syslog-ng.vim %{_datadir}/vim/vim${VIMVERNEW}/syntax || :
fi


%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING README ChangeLog NEWS
%doc doc/examples doc/reference/*txt 
%doc contrib/syslog-ng.conf.*
%doc contrib/syslog2ng contrib/relogger.pl
%{sbindir}/syslog-ng
%{_initrddir}/syslog-ng
%config(noreplace) %{_sysconfdir}//syslog-ng.conf
%config(noreplace) %{_sysconfdir}/sysconfig/syslog-ng
%config(noreplace) %{_sysconfdir}/logrotate.d/syslog
%{_datadir}/%{name}/
%{_mandir}/man5/*.5*
%{_mandir}/man8/*.8*
%ghost %{_datadir}/vim/


%changelog
* Mon Dec 17 2007 Josko Plazonic <plazonic@math.princeton.edu>
- upgrade to latest version to fix a security issue (2.0.6)

* Sun Jul  2 2006 Josko Plazonic <plazonic@math.princeton.edu>
- adapt Fedora Extras pkg for 1.9.11 version
